#! /usr/bin/python3

import time
from Debug import debug_header , debug_alert

MAX_QUEUE = 16

class Queue():
    def __init__(self,sf):
        self.queue = []
        self.index = []
        self.size = []
        self.completed = []
        self.name = []
        for i in range(MAX_QUEUE):
           self.queue.append([])
           self.index.append(0)
           self.size.append(0)
           self.completed.append(False)
           self.name.append(" ")
        self.send_function = sf
        self.id = 0 

    def clear(self,id):
        self.queue[id] = []
        self.size[id] = 0

    def add(self,id,cmd,pattern):
        a = [cmd,pattern,"",False]
        self.queue[id].append(a)
        self.size[id] += 1

    def title(self,id,n):    
        self.name[id] = n 

    def trigger(self,id):
        debug_header(self.name[id])
        self.index[id] = 0
        self.completed[id] = False
        self.id = id
        if (self.size[id] > 0):
          self.send_function(self.queue[id][self.index[id]][0])
          self.index[id] += 1  
  
    def response(self,data):
        id = self.id
        if (self.index[id] > 0) and (self.index[id] <= self.size[id]) :
            if (data.startswith(self.queue[id][self.index[id]-1][1])):
                self.queue[id][self.index[id]-1][3] = True
                if (self.index[id] < self.size[id]):
                  self.send_function(self.queue[id][self.index[id]][0])
                  self.index[id] += 1
                else:
                  self.completed[id] = True
            else:
                self.queue[id][self.index[id]-1][2] = data

    def isCompleted(self,id):
        return self.completed[id]

    def waitCompletion(self,id,timeout=15):
        ta = time.time()
        while ( (time.time() - ta) < timeout ) :
            if self.isCompleted(id):
                break
            time.sleep(1)
        if not self.isCompleted(id):
            debug_alert("[Timeout]")
        return (self.isCompleted(id))    

    def sendData(self,id,data):
        self.clear(id)
        self.add(id,"AT+QISEND=0,{}".format(len(data)),">")
        self.add(id,data,"SEND OK")
        self.trigger(id)

