#! /usr/bin/python3

import threading as t
import serial as s
import re
from Debug import debug
import time

class QuectelBG96(t.Thread):

    def __init__(self,cbm=None,cbg=None):
        t.Thread.__init__(self)
        self.port_modem = "/dev/ttyUSB2"
        self.port_gps = "/dev/ttyUSB3"
        self.terminate = False
        self.callback_modem = cbm
        self.callback_gps = cbg
        self.serial_modem = s.Serial(self.port_modem,timeout=0)
        self.serial_gps = s.Serial(self.port_gps,timeout=0)

    def run(self):
        print("Starting Modem Thread") 

        while not self.terminate :
           time.sleep(1)
           ################################## 
           # Analyze Modem Receiving Buffer #
           ##################################
           buf = self.serial_modem.readline().decode()
           if len(buf):
             a  = re.search('(.*)\r\n',buf,re.IGNORECASE)
             if (a != None) and (len(a.group(1)) > 0):
                if (self.callback_modem):
                   self.callback_modem(a.group(1))
             elif (buf.startswith(">")):
                if (self.callback_modem):
                   self.callback_modem(buf)

           ################################       
           # Analyze GPS Receiving Buffer #
           ################################
           buf = self.serial_gps.readline().decode()
           if len(buf):
              a = re.search('(.*)\r\n',buf,re.IGNORECASE)
              if (a != None) and (len(a.group(1)) > 0) :
                if (self.callback_gps):
                   self.callback_gps(a.group(1))

        print("Finishing Modem Thread")


    def close(self):
        self.terminate = True

    def modem_cmd(self,command):
        self.serial_modem.write(command.encode())
        self.serial_modem.write("\r\n".encode())
        debug("Modem <<",command,'green')

    def gps_cmd(self,command):
        self.serial_gps.write(command.encode())
        self.serial_gps.write("\r\n".encode())
        debug("GPS <<",command,'yellow')



